import monitor.*;

//******************************************************************************/ 
// definizione di una classe che estende Monitor					/
//******************************************************************************/ 

public class PonteMioPeso extends Monitor {

//******************************************************************************/ 
// dichiarazione delle variabili di stato del Monitor				/
//******************************************************************************/ 

    int nauto;	// numero di auto sul ponte
    int pesotot;	// peso totale sul ponte
    int npassaggi;	// numero di auto passate in una direzione
    int dircor;	// direzione corrente del ponte
    final int MaxPeso = 10;	// MaxPesoacita' del ponte in termini di peso
    final int M = 5;	// numero max di passaggi in una direzione

//******************************************************************************/ 
// dichiarazione di variabili condition del Monitor		/
//******************************************************************************/ 

    Cond coda[] = new Cond[2];	// variabili condition


//******************************************************************************/ 
// costruttore e inizializzazione delle variabili di stato del Monitor			/
//******************************************************************************/ 


    public PonteMioPeso() {
    	nauto = 0;
    	pesotot = 0;
    	npassaggi = 0;
	dircor=1;
	coda[0] = new Cond(this);
	coda[1] = new Cond(this);
    }

//******************************************************************************/ 
// dichiarazione e definizione delle procedure di Entry sul Monitor		/
//******************************************************************************/ 

   public void Entra(int dir, int peso, String nomeMacchina) {

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        String volte=""; // indica il numero di volte in cui il porcesso si RIsospende
        int cont = 1;
        
        while (( dircor != dir && nauto != 0) ||
            (dircor == dir && npassaggi >= M && coda[other(dir)].queue()) ||
            ((pesotot + peso) > MaxPeso))
        {
          System.out.print(nomeMacchina+" mi devo "+volte+"sospendere"); 

          if (dircor != dir && nauto != 0)
            System.out.print(" per la direzione"); 
          if (dircor == dir && npassaggi == M)
            System.out.print(" per i passaggi");
          if (pesotot + peso > MaxPeso)
            System.out.print(" per la MaxPesoacita: "+pesotot);
          System.out.println();
          
          volte = "RI"+cont;
          cont++;

          coda[dir].Wait();
        }

        pesotot = pesotot + peso;
        nauto = nauto + 1;
        npassaggi = npassaggi + 1;
        dircor = dir;
       if (coda[dir].queue())
        { System.out.println(nomeMacchina+" entro e segnalo");
        	coda[dir].Signal();
        }

        // come ultima istruzione bisogna invocare esciMonitor
        esciMonitor();
    }

    public void Esci(int dir, int peso, String nomeMacchina) {

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        System.out.println(nomeMacchina + " esce dal ponte");
//        System.out.println(pesotot+" "+peso+" "+nauto);
        pesotot = pesotot - peso;
        nauto = nauto - 1;
        System.out.println(pesotot+" "+peso+" "+nauto);

        // se posso, segnalo una auto della stessa dir
        if (coda[dir].queue() && 
            ((npassaggi < M) || !coda[other(dir)].queue()))
        { System.out.println(nomeMacchina+" faccio la signal");
          coda[dir].Signal();
        }

        if(nauto==0)
        {
          npassaggi = 0; 
          if (coda[other(dir)].queue())
              coda[other(dir)].Signal();
        }
            
        // come ultima istruzione bisogna invocare esciMonitor
        esciMonitor();
        }
        
        private int other(int d) {
          if (d == 0) return 1;
          else return 0;
        }

}    // QUESTA GRAFFA TERMINA LA CLASSE MONITOR 
